% Example 4.2

length=10.; nx=41; ne=21; h=length/(nx-1);
kappa=1.; u0=1.; tp=0.5;
uu(1:nx)=zeros(1,nx); ud(1:nx)=zeros(1,nx); a(1:nx)=zeros(1,nx); roc(1:nx)=zeros(1,nx);
x=((1:nx)-1)*h;
for n=1:nx
    roc(n)=1.+(n-1)*h; a(n)=1.+(n-0.5)*h;
end    
fprintf('    Example 4.2  \n');
fprintf(' \n');
tau=0.0278; nts=round(tp/tau);
fprintf(' Explicit scheme \n'); fprintf('  Space step - %f  \n',h);
fprintf('  Time step  - %f  \n',tau);
for k=1:nts
    time=k*tau;
    [uu]=heat_1d_nun(ud,roc,a,nx,h,time,tau,0.,1,0,'f1_e42','f2_e42','fs_e42');
    ud(1:nx)=uu(1:nx);
end

% Exact solution
for n=1:ne
    p1=(1.+x(n))/sqrt(kappa); p2=1./sqrt(kappa);
    t=[tp;];
    f=invlap('exm42lt',t,0.,1.0e-9,p1,p2);
    ue(n)=u0*sqrt(kappa)*f;
end

plot(x(1:ne),ue(1:ne),'k-',x(1:ne),uu(1:ne),'k--');
xlabel(' x ');
ylabel(' u ');
title(' Example 4.2 ');
clear all;